]> code.delx.au - dotfiles/blob - .bashrc
bash: look for git-prompt.sh in more places
[dotfiles] / .bashrc
1 # shellcheck disable=SC1090 disable=SC1091 # -- Can't follow non-constant source
2
3 ###########################
4 # Settings for all shells #
5 ###########################
6
7 # Set umask, depending on the user ID
8 if [ "$(id -un)" = "root" ]; then
9 umask 0022
10 else
11 umask 0007
12 fi
13
14 # Add ~/bin and subdirs to PATH if needed
15 while read -r p; do
16 echo "$PATH" | tr ':' '\n' | grep -qxF "$p" || PATH="${p}:$PATH"
17 done < <(find -L ~/bin -maxdepth 1 -type d 2> /dev/null)
18
19 # Set EMAIL from the freedesktop environment.d
20 if ls ~/.config/environment.d/*.conf &> /dev/null; then
21 eval "$(awk -F= '{print $0 ";export " $1}' ~/.config/environment.d/*.conf)"
22 fi
23
24 # Pick up SSH agent socket
25 if [ -z "$SSH_AUTH_SOCK" ]; then
26 if [ -r ~/.ssh-agent.env ]; then
27 source ~/.ssh-agent.env
28 else
29 SSH_AUTH_SOCK="/run/user/$(id -u)/keyring/ssh"
30 export SSH_AUTH_SOCK
31 fi
32 fi
33
34
35 ###########################
36 # Interactive shells only #
37 ###########################
38
39 if [ -z "${PS1}" ]; then
40 return
41 fi
42
43
44 ################
45 # bash options #
46 ################
47
48 # Bash should check the terminal size after every command terminates
49 shopt -s checkwinsize
50
51 # Don't attempt to tab-complete an empty line
52 shopt -s no_empty_cmd_completion
53
54 # Prevent overwriting existing files on stdout redirection
55 set -o noclobber
56
57 # Better history
58 shopt -s histappend
59 shopt -s cmdhist
60 export HISTCONTROL='erasedups:ignoredups:ignorespace'
61 export HISTSIZE='100000'
62 export HISTTIMEFORMAT='%F %T '
63
64 [ -r /etc/bash_completion ] && source /etc/bash_completion
65
66 ##################
67 # Terminal setup #
68 ##################
69
70 # Disable CTRL-s / CTRL-q
71 stty -ixon
72
73 # hostname:workingdir
74 PROMPT_COMMAND='echo -ne "\\033]0;$(hostname|cut -d. -f1):${PWD/$HOME/\~}\\007"'
75
76 # Use dark background colors in apps like vim
77 export COLORFGBG='15;0'
78
79 #############
80 # Fancy PS1 #
81 #############
82
83 # Revision control status for git, hg, svn
84
85 function find_up_exists {
86 local d="$PWD"
87 while [ -n "$d" ]; do
88 if [ -e "$d/$1" ]; then
89 return 0
90 fi
91 d="${d%/*}"
92 done
93 return 1
94 }
95
96 for p in /usr/lib/git-core/git-sh-prompt \
97 /usr/share/git/completion/git-prompt.sh \
98 /usr/local/share/git-core/contrib/completion/git-prompt.sh
99 do
100 [ -r "$p" ] && source "$p" && break
101 done
102
103 function my_git_ps1 {
104 find_up_exists .git || return
105 GIT_PS1_SHOWDIRTYSTATE=1 \
106 GIT_PS1_SHOWUNTRACKEDFILES=1 \
107 __git_ps1 ' (%s)' 2> /dev/null
108 }
109
110 function my_hg_ps1 {
111 find_up_exists .hg || return
112 local status
113 status="$(hg status | cut -c1 | sort -u | tr -d ' \n')"
114 echo -n " ($status)"
115 }
116
117 function my_svn_ps1 {
118 find_up_exists .svn || return
119 local status
120 status="$(svn status --ignore-externals 2> /dev/null | cut -c1 | sort -u | tr -d ' \n')"
121 [ -n "$status" ] && echo -n " ($s)"
122 }
123
124 # Two line prompt
125 PS1=''
126 PS1="$PS1"'\[\033[01;31m\]\u@\h\[\033[00m\]:\[\033[01;34m\]\w\[\033[00m\]'
127 PS1="$PS1"'\[\033[01;36m\]$(my_git_ps1 ; my_hg_ps1 ; my_svn_ps1)\[\033[00m\]'
128
129 if ! [[ "$TERM" =~ ^screen ]]; then
130 PS1="$PS1"'\n\$ '
131 else
132 # matches with shelltitle in .screenrc
133 PS1="$PS1"'\n\[\033k\033\\\]\$> '
134 fi
135
136
137 #################################
138 # Display return codes on error #
139 #################################
140
141 function print_exit_code {
142 _exit_msg="\\033[01;33mexit code: $?\\033[00m"
143 if [ -z "${BASH_SOURCE[1]}" ]; then
144 echo -e "$_exit_msg"
145 fi
146 unset _exit_msg
147 }
148 trap print_exit_code ERR
149
150
151 ###############
152 # Pager setup #
153 ###############
154
155 export PAGER='less'
156 export LESS='RS'
157
158
159 ################
160 # Editor setup #
161 ################
162
163 if emacsclient --version &> /dev/null; then
164 export ALTERNATE_EDITOR='vim'
165 export EDITOR='emacsclient --tty'
166
167 if [[ "$TERM" == screen* ]]; then
168 alias edit='emacsclient --tty'
169 else
170 alias edit='emacsclient --create-frame --no-wait'
171 fi
172 else
173 export EDITOR='vim'
174 alias edit='vim'
175 fi
176
177
178 ##########################
179 # ls aliases and colours #
180 ##########################
181
182 # GNU ls colours
183 eval "$(TERM=xterm dircolors 2> /dev/null)"
184
185 # BSD ls colours
186 export LSCOLORS="ExFxCxDxBxEGEDABAGACAD"
187
188 # Lets find the ls
189 if ls --color=auto -v &> /dev/null; then
190 alias ls='ls --color=auto -v'
191 elif gls --color=auto -v &> /dev/null; then
192 alias ls='gls --color=auto -v'
193 elif ls -G &> /dev/null; then
194 alias ls='ls -G'
195 else
196 alias ls='ls -F'
197 fi
198 alias ll='ls -hlF'
199 alias la='ls -ha'
200 alias l='ls -halF'
201
202 ##############
203 # ps aliases #
204 ##############
205
206 alias _psresources='ps -wAo pid,user,%cpu,%mem,stat,start,time,args'
207 if [ "$(uname)" = "Linux" ]; then
208 alias pscpu='_psresources --sort -%cpu|less -S'
209 alias psmem='_psresources --sort -%mem|less -S'
210 alias pstree='ps --forest -weo pid,user:16,args --sort start_time|less -S'
211 alias pstime='ps -wAo pid,user,lstart,args --sort start_time|less -S'
212 else
213 alias pscpu='_psresources -r|less -S'
214 alias psmem='_psresources -m|less -S'
215 alias pstime='ps -wAo pid,user,lstart,args|less -S'
216 fi
217
218 #################
219 # Other aliases #
220 #################
221
222 alias f='find . -iname'
223 if echo x | grep -q --color=auto x &> /dev/null; then
224 alias grep='grep --color=auto'
225 fi
226 alias rg='rg -p'
227 alias scp='scp -o ControlPath=none'
228 alias bc='bc -ql'
229 alias watch='watch -n1'
230 alias sudo='sudo ' # ability to use aliases with sudo
231 alias sudosu='sudo su -l -s /bin/bash'
232 alias python='PYTHONSTARTUP=~/.pythonrc.py python3'
233 alias webshare='python3 -mhttp.server'
234
235 if ! command -v pbcopy &> /dev/null; then
236 alias pbcopy='xsel --clipboard --input'
237 alias pbcopym='xsel --input'
238 alias pbpaste='xsel --clipboard --output'
239 alias pbpastem='xsel --output'
240 fi
241
242 # man with coloured headings and a terminal title
243 function man {
244 echo -ne "\\033]0;man $*\\007"
245
246 env \
247 LESS_TERMCAP_md=$'\E[01;38;5;74m' \
248 LESS_TERMCAP_me=$'\E[0m' \
249 LESS_TERMCAP_us=$'\E[04;38;5;146m' \
250 LESS_TERMCAP_ue=$'\E[0m' \
251 LC_CTYPE=C \
252 man "$@"
253 }
254
255 # Creates the directory if it doesn't exist, and changes into it
256 function mcd {
257 # shellcheck disable=SC2164
258 mkdir -p "$1" && cd "$1"
259 }
260
261 # Sets the nice and ionice priorities for the current shell to the lowest values
262 function slowshell {
263 ionice -c 3 -p $$
264 renice -n 19 -p $$
265 }
266
267 # SSH to an unknown host and print the new known_hosts entry
268 function ssh_new {
269 local new_known_hosts_file
270 new_known_hosts_file="$(mktemp)"
271 ssh -o UserKnownHostsFile="$new_known_hosts_file" "$@" echo 'Connection ok'
272 cat "$new_known_hosts_file"
273 rm -f "$new_known_hosts_file"
274 }
275
276 # SSH without verifying host key
277 function ssh_unsafe {
278 ssh -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null "$@"
279 }
280
281 ###########
282 # The end #
283 ###########
284
285 [ -r ~/.bashrc_local ] && source ~/.bashrc_local